Type dog
	Field x,y
	Field partner.dog
	Field tx,ty
	Field cooldown
End Type

Type pile
	Field x,y
End Type

Type watcher
	Field x,y
	Field range
End Type

Global gfx_w=800
Global gfx_h=600
Graphics gfx_w,gfx_h,0,2
AppTitle "Hundekot Simulator Deluxe"
SeedRnd MilliSecs()
AutoMidHandle True

timer=CreateTimer(50)

;GFX-Generieren
gfx_grass=CreateImage(32,32)
SetBuffer ImageBuffer(gfx_grass)
Color 0,128,0
Rect 0,0,32,32,1
For i=0 To 15
	WritePixel Rand(0,31),Rand(0,31),Rand(50,90) Shl 8
Next

gfx_dog=CreateImage(40,30)
SetBuffer ImageBuffer(gfx_dog)
Color 200,100,0
Oval 2,2,12,9,1
Oval 8,6,25,10,1
Oval 12,12,6,15,1
Oval 25,14,6,13,1
Line 30,10,35,8
Line 30,11,35,9
Color 150,70,0
Oval 12,8,5,4,1
Oval 22,11,4,3,1
Rect 6,5,3,1,0
Rect 5,8,2,2

gfx_pile=CreateImage(20,20)
SetBuffer ImageBuffer(gfx_pile)
Oval 0,10,20,10,1
Oval 5,5,10,10,1

gfx_player=CreateImage(15,26)
SetBuffer ImageBuffer(gfx_player)
Color 0,0,190
Oval 3,2,9,9,1
Rect 7,10,2,10,0
Line 7,15,3,12
Line 8,15,11,12
Line 7,20,3,25
Line 8,20,11,25

;Los gehts
Color 255,255,255
dogcount=Input("Schwierigkeitsgrad (2-10): ")
If dogcount<2 Then dogcount=2
If dogcount>10 Then dogcount=10
Dim dogs.dog(dogcount)
For i=1 To dogcount
	dog.dog=New dog
	dog\x=Rand(10,gfx_w-10)
	dog\y=Rand(10,gfx_h-10)
	dog\cooldown=Rand(50,500)
	dog\tx=-1
	dogs(i)=dog
Next

player_x=Rand(10,gfx_w-10)
player_y=Rand(10,gfx_h-10)
player_bag=False
player_tx=-1;player_ty

pilecount=0
donecount=0
piletime=0
final#=-1

SetBuffer BackBuffer()

Repeat
	If Not KeyDown(32) Then TileBlock gfx_grass,0,0 ;"Absichtliches" Verschwinden des Untergrundes bei D um Fehler zu simulieren
	
	If Rand(0,30000)=0 Then
		RuntimeError("Seltener Ausnahmefehler!")
	EndIf
	
	;Hufchen
	For pile.pile=Each pile
		DrawImage gfx_pile,pile\x,pile\y
		
		piletime=piletime+1
		
		dist=(player_x-pile\x)^2+(player_y-pile\y)^2
		If dist<50 And player_bag Then
			Delete pile
			player_bag=False
			donecount=donecount+1
		EndIf
	Next
	
	If player_x<25 And player_y<30 Then
		player_bag=True
	EndIf
	
	;Hunde
	For dog.dog=Each dog
		DrawImage gfx_dog,dog\x,dog\y
		
		If dog\partner<>Null Then
			;Zu Spielgefhrten laufen
			dist=(dog\partner\x-dog\x)^2+(dog\partner\y-dog\y)^2
			If dist>10 Then
				If dog\partner\x>dog\x Then
					dog\x=dog\x+1
				EndIf
				If dog\partner\x<dog\x Then
					dog\x=dog\x-1
				EndIf
				If dog\partner\y>dog\y Then
					dog\y=dog\y+1
				EndIf
				If dog\partner\y<dog\y Then
					dog\y=dog\y-1
				EndIf
			Else
				dog\partner\partner=Null
				dog\partner=Null
			EndIf
		Else
			If dog\tx>-1 Then
				;Irgendwohin laufen
				dist=(dog\tx-dog\x)^2+(dog\ty-dog\y)^2
				If dist>10 Then
					If dog\tx>dog\x Then
						dog\x=dog\x+1
					EndIf
					If dog\tx<dog\x Then
						dog\x=dog\x-1
					EndIf
					If dog\ty>dog\y Then
						dog\y=dog\y+1
					EndIf
					If dog\ty<dog\y Then
						dog\y=dog\y-1
					EndIf
				Else
					dog\tx=-1
				EndIf
			Else
				;"Leerlauf", also herum springen / whatever
				If Rand(0,1)=1 Then
					dog\x=dog\x+Rand(1,4)*Rand(-1,1)
				Else
					dog\y=dog\y+Rand(1,4)*Rand(-1,1)
				EndIf
				
				;Ausscheidung ablegen
				dog\cooldown=dog\cooldown-1
				If dog\cooldown=0 Then
					pile=New pile
					pile\x=dog\x
					pile\y=dog\y
					dog\cooldown=Rand(50,500)
					pilecount=pilecount+1
				EndIf
				
				;Was anderes machen?
				decide=Rand(0,100)
				If decide=0 Then
					While True
						num=Rand(1,dogcount)
						If dogs(num)<>dog Then
							dog\partner=dogs(num)
							dogs(num)\partner=dog
							Exit
						EndIf
					Wend
				Else If decide=1 Then
					dog\tx=Rand(10,gfx_w-10)
					dog\ty=Rand(10,gfx_h-10)
				EndIf
				
			EndIf
		EndIf
	Next
	
	;Maussteuerung
	If MouseHit(1) Or MouseHit(2) Then
		player_tx=MouseX()
		player_ty=MouseY()
	EndIf
	
	If player_tx>-1 Then
		dist=(player_tx-player_x)^2+(player_ty-player_y)^2
		If dist>20 Then
			If player_tx>player_x Then
				player_x=player_x+5
			EndIf
			If player_tx<player_x Then
				player_x=player_x-5
			EndIf
			If player_ty>player_y Then
				player_y=player_y+5
			EndIf
			If player_ty<player_y Then
				player_y=player_y-5
			EndIf
		Else
			player_tx=-1
		EndIf
	EndIf
	
	;Tastatursteuerung
	If KeyDown(200) Then
		player_y=player_y-5
	EndIf
	If KeyDown(208) Then
		player_y=player_y+5
	EndIf
	If KeyDown(203) Then
		player_x=player_x-5
	EndIf
	If KeyDown(205) Then
		player_x=player_x+5
	EndIf
	If player_x<0 Then player_x=0
	If player_y<0 Then player_y=0
	If player_x>gfx_w Then player_x=gfx_w
	If player_y>gfx_h Then player_y=gfx_h
	
	Color 128,128,128
	Rect 1,1,24,29,1
	Color 255,255,255
	DrawImage gfx_player,player_x,player_y
	
	If player_bag Then
		If First pile<>Null Then
			Text 30,0,"Du hast ein Sackerl, benutze es fr ein Gackerl!"
		Else
			Text 30,0,"Du hast ein Sackerl"
		EndIf
	Else
		Text 30,0,"<- Nimm ein Sackerl!"
	EndIf
	
	score#=(piletime/50.0)/pilecount
	Text 0,gfx_h-30,donecount+ " von "+pilecount+" Gackerl gerumt"
	If pilecount>0 Then
		Text 0,gfx_h-15,"Durchschnittlich "+score#+"sek bentigt"
	EndIf
	
	If pilecount>=dogcount*5 And donecount>=dogcount*5 Then
		If final#<0 Then final#=score#
		;pilecount bzw die gesamte Simulation msste auch gestoppt werden.... aber hey, bissi Buggy ;)
		Cls
		Text gfx_w/2,gfx_h/2-30,"Deine Hunde waren lang genug Gassi.",1,1
		Text gfx_w/2,gfx_h/2-15,"Du hast "+donecount+ " von "+pilecount+" Gackerl aufgesammelt,",1,1
		Text gfx_w/2,gfx_h/2,"durchschnittlich hast du dafr "+final#+"sek gebraucht",1,1
		If final#<(dogcount+1) Then
			Text gfx_w/2,gfx_h/2+15,"Das ist sensationell",1,1
		Else If final#<(dogcount+1)*1.5 Then
			Text gfx_w/2,gfx_h/2+15,"Das ist ganz brauchbar",1,1
		Else
			Text gfx_w/2,gfx_h/2+15,"Das ist schlecht",1,1
		EndIf
		
		Text gfx_w/2,gfx_h/2+45,"(Drcke Esc)",1,1
	EndIf
	
	WaitTimer timer
	Flip 0
	Cls
Until KeyHit(1)
End
;~IDEal Editor Parameters:
;~C#Blitz3D